# funkwlmpv
### Deprecated
Just for fun. A simple TUI media player for FunkWhale instances. Writen on python

Features:
* Simple interface
* Listening to tracks
* Listening to radios (including users/libraries)
* Selecting and listening to albums
* Selecting and listening to artists
* Search by albums, artists
* Switching instance from the public list[1] and the official instances list network.funkwhale.audio (if avalaible)
* All other features are working 50/50

Dependencies:  
* python3.9+
* [mpv](https://mpv.io)
* [fzf](https://github.com/junegunn/fzf)
  
Python dependencies:  
```pip install -r requirements.txt```
Optional: brotli
  
For virtual env just type (ofc after install mpv, fzf, python3):
`./run`

### About cache folder
funkwlmpv has to cache tracks before playing (default disabled "enable_persistent_cache"). Cache is persistent and you should manage it manually because the (script/program) can't clean it automatically.
Cache structure: cache/domain.tld/[track uuid]  
You can play tracks offline, example: mpv --shuffle cache/*/*  
cache_helper.sh - it might be useful for compression cache (lossy: vorbis 128 kbps, no thumbnail)  
  
Also, tnx Inex for his FunkWhale instance (set by default instance)  

[1]**Warning:** may content _unofficial instances_  
**Warning 2:** This software not userfriendly. Maybe developerfriendly.
**Warning 3:** This software optimized for my needs, this can be confuse you.  

___
Simular projects:  
[funkblubber - Naiji's Funkwhale CLI tool writen on Dart](https://git.reisen.church/NaiJi/funkblubber)  
[funkwhale-cli - Official Command line interface to interact with a Funkwhale server, writen on python](https://dev.funkwhale.audio/funkwhale/cli)  
[funkwhale-cli (2) - Same as official, but rewriten on rust](https://gh.phreedom.club/SkyLeite/funkwhale-cli)  
[HTTPDirFS - HTTP Directory Filesystem with a permanent cache, and Airsonic / Subsonic server support! Writen on C](https://gh.phreedom.club/fangfufu/httpdirfs)  

